//DDR SDRAM common interface 
//Automat to give common interface to DDR SDRAM

// Company: Quenne Electric
// Engineer: Andras Bognar

//Simulation top module
`timescale 1ps / 1ps

module ddr_top_topsim(
//CLOCK
	CLK_P,	//clock ponated
	CLK_N,	//clock negated
//SiGNAL LEDS
	LED1,
	LED2,
	LED3,
	LED4
);

//CLOCK SIGNALS
	output CLK_P;	//clock ponated
	output CLK_N;	//clock negated
//LED signals
	output LED1;
	output LED2;
	output LED3;
	output LED4;

//Clock generation 200MHz
	reg clk;
	initial begin clk = 1'b0;
	forever #2500 clk = !clk;
	end

//ClockFB generation 100MHz
	reg clkfb;
	initial begin #7500 clkfb = 1'b0;
	forever #5000 clkfb = !clkfb;
	end	

//SDRAM IF
	wire [12:0]A;
	wire [15:0]DQ;
	wire [1:0]BA;
	wire RAS;
	wire CAS;
	wire WE;
	wire [1:0]QM;
	wire [1:0]DQS;
	wire CS;
	wire CKE;

ddr_top top1(
//200MHz clock in
	clk,
//interface signals to the DDR SDRAM
	A,		//13bit address
	DQ,		//16bit data
	BA,		//bank adress
	RAS,	//row address
	CAS,	//column address
	WE,		//write enable
	QM[0],	//upper data mask
	QM[1],	//lower data mask
	DQS[0],	//upper data strobe
	DQS[1],	//lower data strobe
	CS,		//chip select
	CKE,	//clock enable
	CLK_P,	//clock ponated
	CLK_N,	//clock negated
	clkfb,	//clock feedback
//signal LED outputs [for test report]
	LED1,
	LED2,
	LED3,
	LED4
);

MT46V32M16TG6T ddrram1(
	DQ,
	DQS,
	A,
	BA,
	CLK_P,
	CLK_N,
	CKE,
	CS,
	RAS,
	CAS,
	WE,
	QM
);

endmodule
